#!/bin/sh

# FC should be the path to FontzControl
FC=/root/cfa/me/cfa631
# Display the startup screen. Only shows ONCE.
$FC clear
$FC keydisable
$FC cursor 0
$FC writetext 3 1 "Network"
QUIT=0
UPARROW=`perl -e "print chr(0xde)"`
DNARROW=`perl -e "print chr(0xe0)"`

poll_netdev()
{
	ETH0=`cat /proc/net/dev | grep eth0`
	RECEIVE=`echo $ETH0 | sed 's/^.*:\([0-9]*\) .*/\1/'`
	TRANSMIT=`echo $ETH0 | sed 's/^.*:[0-9]*[ ]*[0-9]*[ ]*[0-9]*[ ]*[0-9]*[ ]*[0-9]*[ ]*[0-9]*[ ]*[0-9]*[ ]*[0-9]*[ ]*\([0-9]*\) .*/\1/'`
}

poll_netdev
OLDRECEIVE=$RECEIVE
OLDTRANSMIT=$TRANSMIT
sleep 1

byteify()
{
	if [ $1 -gt 999999999 ]; then
		t=`expr $1 / 1073741824`
		echo "${t}G"
	elif [ $1 -gt 999999 ]; then
		t=`expr $1 / 1048576`
		echo "${t}M"
	elif [ $1 -gt 999 ]; then
		t=`expr $1 / 1024`
		echo "${t}K"
	else	
		echo "${1}B"
	fi
}

while [ $QUIT -eq 0 ]; do
	DEV="eth0"
	poll_netdev
	DNRATE=`expr \( $RECEIVE - $OLDRECEIVE \) / 10`
	DN=`byteify $DNRATE`
	UPRATE=`expr \( $TRANSMIT - $OLDTRANSMIT \) / 10`
	UP=`byteify $UPRATE`
	$FC writetext 1 2 "$DEV: ${UPARROW} ${UP} ${DNARROW} ${DN}        "
	sleep 1
done
